package main
import(
"context"
"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
"log"
)
func main() {
ctx := context.Background()
s := conductoronesdkgo.New(
conductoronesdkgo.WithSecurity(shared.Security{
BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
Oauth: "<YOUR_OAUTH_HERE>",
}),
)
res, err := s.SignInPolicy.Create(ctx, nil)
if err != nil {
log.Fatal(err)
}
if res.SignInPolicyServiceCreateResponse != nil {
// handle response
}
}curl --request POST \
--url https://{tenantDomain}.conductor.one/api/v1/sign-in-policies \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"displayName": "<string>",
"allowedMfaTypes": [],
"allowedPrimaryTypes": [],
"defaultOutcome": {
"allow": {},
"challengeRequired": {
"types": []
},
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": {
"credentialTypes": []
},
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
},
"priority": 123,
"rules": [
{
"description": "<string>",
"id": "<string>",
"matchCel": "<string>",
"outcome": {
"allow": {},
"challengeRequired": {
"types": []
},
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": {
"credentialTypes": []
},
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
}
}
]
}
'import requests
url = "https://{tenantDomain}.conductor.one/api/v1/sign-in-policies"
payload = {
"displayName": "<string>",
"allowedMfaTypes": [],
"allowedPrimaryTypes": [],
"defaultOutcome": {
"allow": {},
"challengeRequired": { "types": [] },
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": { "credentialTypes": [] },
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
},
"priority": 123,
"rules": [
{
"description": "<string>",
"id": "<string>",
"matchCel": "<string>",
"outcome": {
"allow": {},
"challengeRequired": { "types": [] },
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": { "credentialTypes": [] },
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
}
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
displayName: '<string>',
allowedMfaTypes: [],
allowedPrimaryTypes: [],
defaultOutcome: {
allow: {},
challengeRequired: {types: []},
deny: {reasonAdmin: '<string>', reasonUser: '<string>'},
enrollmentRequired: {credentialTypes: []},
stepUpRequired: {maxAgeSeconds: 123, types: []}
},
priority: 123,
rules: [
{
description: '<string>',
id: '<string>',
matchCel: '<string>',
outcome: {
allow: {},
challengeRequired: {types: []},
deny: {reasonAdmin: '<string>', reasonUser: '<string>'},
enrollmentRequired: {credentialTypes: []},
stepUpRequired: {maxAgeSeconds: 123, types: []}
}
}
]
})
};
fetch('https://{tenantDomain}.conductor.one/api/v1/sign-in-policies', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"signInPolicy": {
"allowedMfaTypes": [],
"allowedPrimaryTypes": [],
"createdAt": "2023-11-07T05:31:56Z",
"defaultOutcome": {
"allow": {},
"challengeRequired": {
"types": []
},
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": {
"credentialTypes": []
},
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
},
"deletedAt": "2023-11-07T05:31:56Z",
"displayName": "<string>",
"id": "<string>",
"isBuiltin": true,
"priority": 123,
"rules": [
{
"description": "<string>",
"id": "<string>",
"matchCel": "<string>",
"outcome": {
"allow": {},
"challengeRequired": {
"types": []
},
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": {
"credentialTypes": []
},
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
}
}
],
"updatedAt": "2023-11-07T05:31:56Z"
}
}Create
Create a sign-in policy.
package main
import(
"context"
"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
"log"
)
func main() {
ctx := context.Background()
s := conductoronesdkgo.New(
conductoronesdkgo.WithSecurity(shared.Security{
BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
Oauth: "<YOUR_OAUTH_HERE>",
}),
)
res, err := s.SignInPolicy.Create(ctx, nil)
if err != nil {
log.Fatal(err)
}
if res.SignInPolicyServiceCreateResponse != nil {
// handle response
}
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
This API uses OAuth2 with the Client Credential flow. Client Credentials must be sent in the BODY, not the headers. For an example of how to implement this, refer to the c1TokenSource.Token() function.
Body
The SignInPolicyServiceCreateRequest message.
A human-readable name for the policy.
The credential types accepted as a second factor.
CREDENTIAL_TYPE_UNSPECIFIED, CREDENTIAL_TYPE_PASSKEY, CREDENTIAL_TYPE_PASSWORD, CREDENTIAL_TYPE_TOTP, CREDENTIAL_TYPE_EMAIL_OTP, CREDENTIAL_TYPE_RECOVERY_CODE, CREDENTIAL_TYPE_DELEGATED_GOOGLE, CREDENTIAL_TYPE_DELEGATED_MICROSOFT, CREDENTIAL_TYPE_UPSTREAM_IDP The primary credential types users may sign in with.
CREDENTIAL_TYPE_UNSPECIFIED, CREDENTIAL_TYPE_PASSKEY, CREDENTIAL_TYPE_PASSWORD, CREDENTIAL_TYPE_TOTP, CREDENTIAL_TYPE_EMAIL_OTP, CREDENTIAL_TYPE_RECOVERY_CODE, CREDENTIAL_TYPE_DELEGATED_GOOGLE, CREDENTIAL_TYPE_DELEGATED_MICROSOFT, CREDENTIAL_TYPE_UPSTREAM_IDP PolicyOutcome is the effect of a matched rule. Exactly one kind is set.
This message contains a oneof named kind. Only a single field of the following list may be set at a time:
- allow
- deny
- stepUpRequired
- challengeRequired
- enrollmentRequired
Show child attributes
Show child attributes
When a user matches more than one policy, the policy with the highest priority applies.
The ordered rule cascade.
Show child attributes
Show child attributes
Response
Successful response
The SignInPolicyServiceCreateResponse message.
SignInPolicy defines how users sign in.
Show child attributes
Show child attributes
Was this page helpful?